<?php
/**
 * Created by PhpStorm.
 * User: Denis
 * Date: 26.03.2015
 * Time: 15:35
 */

//require_once(dirname(__FILE__) .'/config.php');


class Dynamic_Watermark_DBUpdater {

    static $currVersion;




    static function version_to_func_name($newVersion){
        $tempNew = str_replace(".", "_", $newVersion);

        return "update_to_$tempNew";
    }

    static function update(){
        global $cc_dw_config;

        self::$currVersion = $cc_dw_config['version'];
        $oldVersion = get_option( 'cc_dw_curr_version', '0.0.0' );

        $funcContainer = new Dynamic_Watermark_Base_FunctionContainer();
        $funcContainer->legacy();

        if($oldVersion === self::$currVersion)return;



        update_option( 'cc_dw_curr_version',self::$currVersion );
//        $oldVersionIndex = array_search($oldVersion, PHMM_DBUpdater::$versions);
//        $funcContainer = new PHMM_FunctionContainer();

        $functions = get_class_methods('Dynamic_Watermark_Base_FunctionContainer'); //get all functions
        $funcName = self::version_to_func_name($oldVersion); //get the function which was (potentially) executed last time

        if(!function_exists('cc_dw_filter_functions')){
            function cc_dw_filter_functions($v){return strpos($v,'update_to_') === 0;}
        }

        $update_funcs = array_filter($functions, 'cc_dw_filter_functions'); //we want only update_to_ functions!
        $update_funcs[] = $funcName; //insert last executed function name to make sure it is in the array
        $update_funcs = array_unique($update_funcs); //remove our entry if it was already contained
        natsort($update_funcs); //sort the functions s.t. they are executed in the correct order!
        $update_funcs = array_values($update_funcs); //natsort sorts the keys too. we do not want this, cut them off.


        $oldVersionIndex = array_search($funcName, $update_funcs); //now lookup the current index, s.t. we can apply all remaining functions

//        for($i = $oldVersionIndex+1; $i< count(PHMM_DBUpdater::$versions); $i++ ){
//            $funcName = PHMM_DBUpdater::version_to_func_name(PHMM_DBUpdater::$versions[$i]);
//
//            if(method_exists ($funcContainer, $funcName)){ //we have to perform some operations on the database
//                $funcContainer->$funcName();
//            }
//        }
        for($i = $oldVersionIndex+1; $i< count($update_funcs); $i++ ){ //start from $oldVersionIndex+1 because we already applied $oldVersionIndex in the last version
            $funcName = $update_funcs[$i]; //helper

            if(method_exists ($funcContainer, $funcName)){ //we have to perform some operations on the database
                $funcContainer->$funcName();
            }
        }

        /////////// AFTER INSTALL/UPGRADE
        do_action('codeneric/dw/base-plugin-updated');

    }

}

class Dynamic_Watermark_Base_FunctionContainer{
    public function legacy(){

    }

    public function update_to_1_0_0(){
        $options = get_option( 'cc_dynamic_watermark_settings', array() );
        $options['enable_watermarking'] = isset($options['enable_watermarking']) ? $options['enable_watermarking'] : 1;
        update_option('cc_dynamic_watermark_settings', $options);
    }
}
