<?php

/**
 * The admin-specific functionality of the plugin.
 *
 * @link       http://codeneric.com
 * @since      1.0.0
 *
 * @package    Dynamic_Watermark_Base
 * @subpackage Dynamic_Watermark_Base/admin
 */

/**
 * The admin-specific functionality of the plugin.
 *
 * Defines the plugin name, version, and two examples hooks for how to
 * enqueue the admin-specific stylesheet and JavaScript.
 *
 * @package    Dynamic_Watermark_Base
 * @subpackage Dynamic_Watermark_Base/admin
 * @author     Codeneric <support@codeneric.com>
 */

require_once(dirname(__FILE__).'/../includes/common.php');

class Dynamic_Watermark_Base_Admin {


	private $plugin_name;
	private $version;
	private $slug;

	public function __construct( $plugin_name='', $version='', $slug='') {
		global $cc_dw_config;
		$this->plugin_name =    $cc_dw_config['plugin_name'];
		$this->version     =    $cc_dw_config['version'];
		$this->slug     =       $cc_dw_config['slug'];



	}


	public function watermark($args){
		require_once(dirname(__FILE__).'/../includes/watermarker.php');
		$WM = new Dynamic_Watermark_Watermarker();
		$WM->watermark_image($args);
	}

	public function enqueue_scripts(){
		wp_enqueue_media(  );
//		wp_localize_script('cc_dw_')
		wp_register_script('cc_dw_media_uploader', plugin_dir_url(__FILE__). 'js/media-uploader.js', array('jquery'));
		wp_enqueue_script('cc_dw_media_uploader');
	}

	public function update_database(){
		require_once(dirname(__FILE__).'/DBUpdater.php');
		Dynamic_Watermark_DBUpdater::update();
	}

	




}
