<?php
add_action( 'admin_menu', 'cc_dw_add_admin_menu' );
add_action( 'admin_init', 'cc_dynamic_watermark_settings_init' );


function cc_dw_add_admin_menu(  ) {

    add_options_page( 'Dynamic Watermark', 'Dynamic Watermark', 'manage_options', 'dynamic_watermark', 'cc_dw_options_page' );

}


function cc_dynamic_watermark_settings_init(  ) {

    register_setting( 'cc_dw_pluginPage', 'cc_dynamic_watermark_settings' );

    add_settings_section(
        'cc_dw_cc_dw_pluginPage_section',
        __( '', 'wordpress' ),
        'cc_dynamic_watermark_settings_section_callback',
        'cc_dw_pluginPage'
    );



    add_settings_field(
        'cc_dw_checkbox_field_0',
        __( 'Enable watermarking', 'wordpress' ),
        'enable_watermarking',
        'cc_dw_pluginPage',
        'cc_dw_cc_dw_pluginPage_section'
    );

    add_settings_field(
        'cc_dw_checkbox_print_user_id',
        __( 'Print user ID', 'wordpress' ),
        'print_user_id',
        'cc_dw_pluginPage',
        'cc_dw_cc_dw_pluginPage_section'
    );

    add_settings_field(
        'cc_dw_upload_button',
        __( 'Change watermark (PNG only)', 'wordpress' ),
        'upload_watermark',
        'cc_dw_pluginPage',
        'cc_dw_cc_dw_pluginPage_section'
    );

    add_settings_field(
        'cc_dw_exclude_images',
        __( 'Exclude images (tbi)', 'wordpress' ),
        'tbi',
        'cc_dw_pluginPage',
        'cc_dw_cc_dw_pluginPage_section'
    );

    add_settings_field(
        'cc_dw_position_watermark',
        __( 'Position watermark', 'wordpress' ),
        'cc_dw_position_watermark',
        'cc_dw_pluginPage',
        'cc_dw_cc_dw_pluginPage_section'
    );

    add_settings_field(
        'cc_dw_scale_watermark',
        __( 'Scale watermark', 'wordpress' ),
        'cc_dw_scale_watermark',
        'cc_dw_pluginPage',
        'cc_dw_cc_dw_pluginPage_section'
    );




}


function enable_watermarking(  ) {

    $options = get_option( 'cc_dynamic_watermark_settings', array() );
    $options['enable_watermarking'] = isset($options['enable_watermarking']) ? $options['enable_watermarking'] : 0;
    ?>
    <input type='checkbox' name='cc_dynamic_watermark_settings[enable_watermarking]' <?php checked( $options['enable_watermarking'], 1 ); ?> value='1'>
    <?php

}

function print_user_id(  ) {

    $options = get_option( 'cc_dynamic_watermark_settings', array() );
    $options['print_user_id'] = isset($options['print_user_id']) ? $options['print_user_id'] : 0;
    ?>
    <input type='checkbox' name='cc_dynamic_watermark_settings[print_user_id]' <?php checked( $options['print_user_id'], 1 ); ?> value='1'>
    <?php

}

function upload_watermark(  ) {

    $options = get_option( 'cc_dynamic_watermark_settings', array() );
    $default_img_url = plugin_dir_url(__FILE__).'../../assets/watermark.png';
    $options['watermark_image_url'] = isset($options['watermark_image_url']) ? $options['watermark_image_url'] : $default_img_url;
    $options['watermark_image_id'] = isset($options['watermark_image_id']) ? $options['watermark_image_id'] : '';

    ?>
<!--    <input type='button' value='Upload/Select watermark' class="upload_image_button">-->
    <img src="<?php echo $options['watermark_image_url']; ?>" class="upload_image_button" height="100px" style="background-color: grey;" />
    <input type='text' id="watermark_image_url" name='cc_dynamic_watermark_settings[watermark_image_url]' value='<?php echo $options['watermark_image_url']; ?>' hidden >
    <input type='text' id="watermark_image_id" name='cc_dynamic_watermark_settings[watermark_image_id]' value='<?php echo $options['watermark_image_id']; ?>' hidden >
    <?php

}

function tbi(  ) {
    ?>
    <!--    <input type='button' value='Upload/Select watermark' class="upload_image_button">-->
    <p>To Be Implemented</p>
    <?php

}

function cc_dw_position_watermark()
{
    $options = get_option( 'cc_dynamic_watermark_settings', array() );
//    if(!isset($options['cc_photo_download_text']))
//        $options['cc_photo_download_text'] = 'Download all';


    ?>


    <select name='cc_dynamic_watermark_settings[watermark_position]' id="cc_dw_watermark_position"
            value="<?php echo isset($options['watermark_position']) ? $options['watermark_position'] : 'center'; ?>">

        <?php

        $position_map = array(
            'center' => array('h' => 0.5, 'v' => 0.5),
            'left_bottom' => array('h' => 0.1, 'v' => 0.9),
            'right_bottom' => array('h' => 0.9, 'v' => 0.9),
            'left_top' => array('h' => 0.1, 'v' => 0.1),
            'right_top' => array('h' => 0.9, 'v' => 0.1)
        );

        $opts = array('center','left_bottom', 'right_bottom', 'left_top', 'right_top');
        $texts = array('center','left bottom', 'right bottom', 'left top', 'right top');
        $target = isset($options['watermark_position']) ? $options['watermark_position'] : 'center';

        update_option('codeneric/dw/watermark/pos-h', $position_map[$target]['h'] );
        update_option('codeneric/dw/watermark/pos-v', $position_map[$target]['v'] );

        foreach ($opts as $i => $opt) {
            $selected = '';
            if ($target === $opt)
                $selected = 'selected';

            echo "<option value=\"$opt\" $selected >".$texts[$i]."</option>";
        }
        ?>

    </select>
<!--    <input class="hidden" name='codeneric/dw/watermark/pos-h' id="cc_dw_watermark_h"/>-->
<!--    <input class="hidden" name='codeneric/dw/watermark/pos-v' id="cc_dw_watermark_v"/>-->
<!--    <script>-->
<!--        var position_map = {-->
<!--            center: {h:0.5, v:0.5},-->
<!--            left_bottom: {h:0.1, v:0.9},-->
<!--            right_bottom: {h:0.9, v:0.9},-->
<!--            left_top: {h:0.1, v:0.1},-->
<!--            right_top: {h:0.9, v:0.1}-->
<!--        };-->
<!--        var opt = jQuery('#cc_dw_watermark_position').val();-->
<!--        jQuery('#cc_dw_watermark_h').val(position_map[opt].h);-->
<!--        jQuery('#cc_dw_watermark_v').val(position_map[opt].v);-->
<!--    </script>-->


    <?php
}


function cc_dw_scale_watermark()
{
    $options = get_option( 'cc_dynamic_watermark_settings', array() );
//    if(!isset($options['cc_photo_download_text']))
//        $options['cc_photo_download_text'] = 'Download all';


    ?>


    <select name='cc_dynamic_watermark_settings[watermark_scale]' id="cc_dw_watermark_scale"
            value="<?php echo isset($options['watermark_scale']) ? $options['watermark_scale'] : '30'; ?>">

        <?php

        $position_map = array(
            'center' => array('h' => 0.5, 'v' => 0.5),
            'left_bottom' => array('h' => 0.1, 'v' => 0.9),
            'right_bottom' => array('h' => 0.9, 'v' => 0.9),
            'left_top' => array('h' => 0.1, 'v' => 0.1),
            'right_top' => array('h' => 0.9, 'v' => 0.1)
        );

        $opts = array('10','20', '30', '40', '50', '60', '70', '80', '90', '100');
        $texts = array('10%','20%', '30%', '40%', '50%', '60%', '70%', '80%', '90%', '100%');
        $target = isset($options['watermark_scale']) ? $options['watermark_scale'] : '30';

        update_option('codeneric/dw/watermark/scale', intval($target)/100 );
//        update_option('codeneric/dw/watermark/pos-v', $position_map[$target]['v'] );

        foreach ($opts as $i => $opt) {
            $selected = '';
            if ($target === $opt)
                $selected = 'selected';

            echo "<option value=\"$opt\" $selected >".$texts[$i]."</option>";
        }
        ?>

    </select>



    <?php
}

function cc_dw_steganography_decrypt()
{

//    if(!isset($options['cc_photo_download_text']))
//        $options['cc_photo_download_text'] = 'Download all';


    ?>


    <input type="text" id="steganography_img_url" />
    <input type="button" value="check" id="steganography_decrypt" />
    <script>
        jQuery('#steganography_decrypt').on('click', function(){
            jQuery.post(ajaxurl, {action: 'cc_dw_steganography_decrypt', url: jQuery('#steganography_img_url').val()});
        });
    </script>





    <?php
}

function cc_dynamic_watermark_settings_section_callback(  ) {

//    echo __( 'This section description', 'wordpress' );

}


function cc_dw_options_page(  ) {

    ?>
    <form action='options.php' method='post'>

        <h2>Dynamic Watermark</h2>

        <?php
        settings_fields( 'cc_dw_pluginPage' );
        do_settings_sections( 'cc_dw_pluginPage' );
        submit_button();
        ?>

    </form>
    <?php

}

?>