<?php

/**
 * The plugin bootstrap file
 *
 * This file is read by WordPress to generate the plugin information in the plugin
 * admin area. This file also includes all of the dependencies used by the plugin,
 * registers the activation and deactivation functions, and defines a function
 * that starts the plugin.
 *
 * @link              http://codeneric.com
 * @since             1.0.0
 * @package           Dynamic_Watermark
 *
 * @wordpress-plugin
 * Plugin Name:       Dynamic Watermark
 * Plugin URI:        codeneric.com
 * Description:       Apply non-destructive watermarks on your images.
 * Version:           1.2.0
 * Author:            Codeneric
 * Author URI:        http://codeneric.com
 * License:           GPL-2.0+
 * License URI:       http://www.gnu.org/licenses/gpl-2.0.txt
 * Text Domain:       dynamic-watermark
 * Domain Path:       /languages
 */

// If this file is called directly, abort.
if ( ! defined( 'WPINC' ) ) {
	die;
}


/**
 * The code that runs during plugin activation.
 * This action is documented in includes/activator.php
 */
function activate_dynamic_watermark() {
	require_once dirname( __FILE__ ) . '/includes/activator.php';
	Dynamic_Watermark_Base_Activator::activate();
}

/**
 * The code that runs during plugin deactivation.
 * This action is documented in includes/deactivator.php
 */
function deactivate_dynamic_watermark() {
	require_once dirname( __FILE__ ) . '/includes/deactivator.php';
	Dynamic_Watermark_Base_Deactivator::deactivate();
}

register_activation_hook( __FILE__, 'activate_dynamic_watermark' );
register_deactivation_hook( __FILE__, 'deactivate_dynamic_watermark' );

/**
 * The core plugin class that is used to define internationalization,
 * admin-specific hooks, and public-facing site hooks.
 */
require dirname( __FILE__ ) . '/includes/base.php';

/**
 * Begins execution of the plugin.
 *
 * Since everything within the plugin is registered via hooks,
 * then kicking off the plugin from this point in the file does
 * not affect the page life cycle.
 *
 * @since    1.0.0
 */

function run_dynamic_watermark() {

	require_once (dirname(__FILE__). '/admin/subpages/options.php');
	global $cc_dw_config;
	if(!isset($cc_dw_config)) {
		require_once dirname(__FILE__) . '/config.php';
		$config = Dynamic_Watermark_Base_Config::set('%PLUGIN_ENV%');
		$GLOBALS["cc_dw_config"] = $config;
	}
	$plugin = new Dynamic_Watermark_Base();
	$plugin->run();


}
run_dynamic_watermark();
