<?php

/**
 * Fired during plugin activation
 *
 * @link       http://codeneric.com
 * @since      1.0.0
 *
 * @package    Dynamic_Watermark_Base
 * @subpackage Dynamic_Watermark_Base/includes
 */

/**
 * Fired during plugin activation.
 *
 * This class defines all code necessary to run during the plugin's activation.
 *
 * @since      1.0.0
 * @package    Dynamic_Watermark_Base
 * @subpackage Dynamic_Watermark_Base/includes
 * @author     Codeneric <support@codeneric.com>
 */



class Dynamic_Watermark_Base_Activator {

	/**
	 * Short Description. (use period)
	 *
	 * Long Description.
	 *
	 * @since    1.0.0
	 */
	public static function activate() {

		$upload_dir = wp_upload_dir();
		$upload_dir = $upload_dir['basedir'];

		require_once(dirname(__FILE__) . '/../protect_images/generate_htaccess.php');
		$htaccess_suc = Dynamic_Watermark_Base_Generate_Htaccess();

		if($htaccess_suc){

			if(file_exists("$upload_dir/.htaccess")){
				//				unlink("$upload_dir/.htaccess");
				$htaccess_content = file_get_contents ( "$upload_dir/.htaccess");
//				$htaccess_content = preg_replace('#BEGIN-DYNAMIC-WATERMARK*#END-DYNAMIC-WATERMARK', '', $htaccess_content);
//				$htaccess_content = preg_replace('|(#BEGIN-DYNAMIC-WATERMARK)(.*)(#END-DYNAMIC-WATERMARK)|', '', $htaccess_content);
				$startPoint = "#BEGIN-DYNAMIC-WATERMARK";
				$endPoint = "#END-DYNAMIC-WATERMARK";

				$htaccess_content = preg_replace('|('.preg_quote($startPoint).')(.*)('.preg_quote($endPoint).')|si', '', $htaccess_content);

				$custom_htaccess_content = file_get_contents ( dirname(__FILE__) . '/../protect_images/apache_htaccess');
				$htaccess_content .= PHP_EOL . $custom_htaccess_content;
				$myfile = fopen( "$upload_dir/.htaccess", "w" );
				if($myfile !== false) {
					if (fwrite($myfile, $htaccess_content) !== false)
						fclose($myfile);
				}

			}


			if(! file_exists("$upload_dir/.htaccess")) {
				copy(dirname(__FILE__) . '/../protect_images/apache_htaccess', "$upload_dir/.htaccess");
			}
		}



		if ( get_option( 'cc_dynamic_watermark_id' ) === false ) {
			$uniqid = uniqid('', true);
			$uniqid = str_replace('.','',$uniqid);
			update_option( 'cc_dynamic_watermark_id', $uniqid );
		}





	}

}
