<?php

/**
 * Fired during plugin deactivation
 *
 * @link       http://codeneric.com
 * @since      1.0.0
 *
 * @package    Dynamic_Watermark_Base
 * @subpackage Dynamic_Watermark_Base/includes
 */

/**
 * Fired during plugin deactivation.
 *
 * This class defines all code necessary to run during the plugin's deactivation.
 *
 * @since      1.0.0
 * @package    Dynamic_Watermark_Base
 * @subpackage Dynamic_Watermark_Base/includes
 * @author     Codeneric <support@codeneric.com>
 */
class Dynamic_Watermark_Base_Deactivator {
	/**
	 * Short Description. (use period)
	 *
	 * Long Description.
	 *
	 * @since    1.0.0
	 */
	public static function deactivate() {
		$upload_dir = wp_upload_dir();
		$upload_dir = $upload_dir['basedir'];
		if(file_exists("$upload_dir/.htaccess")) {
			$htaccess_content = file_get_contents ( "$upload_dir/.htaccess");
			$startPoint = "#BEGIN-DYNAMIC-WATERMARK";
			$endPoint = "#END-DYNAMIC-WATERMARK";
			$htaccess_content = preg_replace('|('.preg_quote($startPoint).')(.*)('.preg_quote($endPoint).')|si', '', $htaccess_content);
			$myfile = fopen( "$upload_dir/.htaccess", "w" );
			if($myfile !== false) {
				if (fwrite($myfile, $htaccess_content) !== false)
					fclose($myfile);
			}
		}
	}

}
