<?php
/**
 * Created by PhpStorm.
 * User: denis_000
 * Date: 25.04.2016
 * Time: 19:59
 */

class Dynamic_Watermark_Base_Protect_Images
{

    public $config;
    public function __construct( ) {

        global $cc_dw_config;
        $this->config = $cc_dw_config;
    }


    public function provide_file($filename){

        $options = get_option('cc_dynamic_watermark_settings', array());
        $watermark_id = isset($options['watermark_image_id']) ? $options['watermark_image_id'] : 0;
        if( isset($options['enable_watermarking']) &&
            !empty($options['enable_watermarking']) &&
            getimagesize($filename) !== false &&
            has_action('codeneric/dw/watermark') &&
            !$this->file_belongs_to_attachment($filename, $watermark_id)
        ){ //image requested

            $args = array('file'=>$filename);
            do_action('codeneric/dw/watermark', $args);
            exit;
        }


        $file = @fopen($filename, 'rb');
        $buffer = 1024 * 8;
        header('Content-Description: File Transfer');
        header('Content-Type: application/octet-stream');
        header('Content-Disposition: attachment; filename="'.basename($filename).'"');

        while (!feof($file)) {
            echo fread($file, $buffer);
            flush();
        }
        fclose($file);

        exit;
    }

    public function file_belongs_to_attachment($file, $id){
        $url = $this->path_to_url($file);

        $attach_url = wp_get_attachment_url( $id );
        if($attach_url === $url)return true;
        $sizes = get_intermediate_image_sizes();
        $sizes = is_array($sizes) ? $sizes : array();
        foreach($sizes as $size){
            $data = wp_get_attachment_image_src( $id, $size );
            if(is_array($data) && $data[0] === $url )
                return true;
        }
        return false;

    }

    public function path_to_url($filepath){
        $upload = wp_upload_dir();
        $upload_url = $upload['baseurl'];
        $upload_dir = $upload['basedir'];
        $rel_path = str_replace($upload_dir, '', $filepath );
        $fileurl = $upload_url.$rel_path;
        return $fileurl;
    }

   

}